package betterwithmods.module.compat;

import betterwithmods.module.CompatFeature;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.common.event.FMLInterModComms;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;

public class ThermalExpansion extends CompatFeature {
    public ThermalExpansion() {
        super("thermalexpansion");
    }

    @Override
    public void preInit(FMLPreInitializationEvent event) {
        removeSmelterRecipe(new ItemStack(Items.field_151133_ar), ItemStack.field_190927_a);
        addSmelterRecipe(6000, new ItemStack(Items.field_151133_ar), ItemStack.field_190927_a, new ItemStack(Items.field_191525_da, 7));
    }

    public void addSmelterRecipe(int energy, ItemStack primary, ItemStack secondary, ItemStack output) {
        NBTTagCompound tag = new NBTTagCompound();
        tag.func_74768_a("energy", energy);
        tag.func_74782_a("primaryInput", primary.serializeNBT());
        tag.func_74782_a("secondaryInput", secondary.serializeNBT());
        tag.func_74782_a("primaryOutput", output.serializeNBT());
        FMLInterModComms.sendMessage(modid, ADD_SMELTER_RECIPE, tag);
    }

    public void removeSmelterRecipe(ItemStack primary, ItemStack secondary) {
        NBTTagCompound tag = new NBTTagCompound();
        tag.func_74782_a("primaryInput", primary.serializeNBT());
        tag.func_74782_a("secondaryInput", secondary.serializeNBT());

        FMLInterModComms.sendMessage(modid, REMOVE_SMELTER_RECIPE, tag);
    }

    public static final String ADD_SMELTER_RECIPE = "addsmelterrecipe";
    public static final String REMOVE_SMELTER_RECIPE = "removesmelterrecipe";
}
